
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>《Spring 5 官方文档》16.ORM和数据访问（二） / iVAN</title>

    <meta name="description" content="《Spring 5 官方文档》16.ORM和数据访问（二） 16.3.4编程式事务划分 开发者可以在应用程序的更高级别上对事务进行标定,而不用考虑低级别的数据访问执行了多少操作.这样不会对业务服务的实现进行限制:只需要定义一个Spring的PlatformTransactionManager即可.当然,PlatformTransactionManager可以从多处获取,但最好是通过setTransactionManager(..)方法以Bean来注入,正如ProductDAO应该由setProductDao(..)方法配置一样.下面的代码显示Spring">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">《Spring 5 官方文档》16.ORM和数据访问（二）</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<h3>16.3.4编程式事务划分</h3>
<p>开发者可以在应用程序的更高级别上对事务进行标定，而不用考虑低级别的数据访问执行了多少操作。这样不会对业务服务的实现进行限制；只需要定义一个Spring的<code>PlatformTransactionManager</code>即可。当然，<code>PlatformTransactionManager</code>可以从多处获取，但最好是通过<code>setTransactionManager(..)</code>方法以Bean来注入，正如<code>ProductDAO</code>应该由<code>setProductDao(..)</code>方法配置一样。下面的代码显示Spring应用程序上下文中的事务管理器和业务服务的定义，以及业务方法实现的示例：</p>
<ol>
<li><code>&lt;bean id="myTxManager" class="org.springframework.orm.hibernate5.HibernateTransactionManager"&gt;</code></li>
<li><code>&lt;property name="sessionFactory" ref="mySessionFactory"/&gt;</code></li>
<li><code>&lt;/bean&gt;</code></li>
<li><code></code></li>
<li><code>&lt;bean id="myProductService" class="product.ProductServiceImpl"&gt;</code></li>
<li><code>&lt;property name="transactionManager" ref="myTxManager"/&gt;</code></li>
<li><code>&lt;property name="productDao" ref="myProductDao"/&gt;</code></li>
<li><code>&lt;/bean&gt;</code></li>
<li><code>&lt;/beans&gt;</code></li>
</ol>
<ol>
<li><code>public class ProductServiceImpl implements ProductService {</code></li>
<li><code></code></li>
<li><code>private TransactionTemplate transactionTemplate;</code></li>
<li><code>private ProductDao productDao;</code></li>
<li><code></code></li>
<li><code>public void setTransactionManager(PlatformTransactionManager transactionManager) {</code></li>
<li><code>this.transactionTemplate = new TransactionTemplate(transactionManager);</code></li>
<li><code>}</code></li>
<li><code></code></li>
<li><code>public void setProductDao(ProductDao productDao) {</code></li>
<li><code>this.productDao = productDao;</code></li>
<li><code>}</code></li>
<li><code></code></li>
<li><code>public void increasePriceOfAllProductsInCategory(final String category) {</code></li>
<li><code>this.transactionTemplate.execute(new TransactionCallbackWithoutResult() {</code></li>
<li><code>public void doInTransactionWithoutResult(TransactionStatus status) {</code></li>
<li><code>List productsToChange = this.productDao.loadProductsByCategory(category);</code></li>
<li><code>// do the price increase...</code></li>
<li><code>}</code></li>
<li><code>});</code></li>
<li><code>}</code></li>
<li><code>}</code></li>
</ol>
<p>Spring的<code>TransactionInterceptor</code>允许任何检查的应用异常到<code>callback</code>代码中去，而<code>TransactionTemplate</code>还会非受检异常触发进行回调。<code>TransactionTemplate</code>则会因为非受检异常或者是由应用标记事务回滚(通过<code>TransactionStatus</code>)。<code>TransactionInterceptor</code>也是一样的处理逻辑，但是同时还允许基于方法配置回滚策略。</p>
<h3>16.3.5事务管理策略</h3>
<p>无论是<code>TransactionTemplate</code>或者是<code>TransactionInterceptor</code>都将实际的事务处理代理到<code>PlatformTransactionManager</code>实例上来进行处理的，这个实例的实现可以是一个<code>HibernateTransactionManager</code>(包含一个Hibernate的<code>SessionFactory</code>通过使用<code>ThreadLocal</code>的<code>Session</code>)，也可以是<code>JatTransactionManager</code>(代理到容器的JTA子系统)。开发者甚至可以使用一个自定义的<code>PlatformTransactionManager</code>的实现。现在，如果应用有需求需要需要部署分布式事务的话，只是一个配置变化，就可以从本地Hibernate事务管理切换到JTA。简单地用Spring的JTA事务实现来替换Hibernate事务管理器即可。因为引用的<code>PlatformTransactionManager</code>的是通用事务管理API，事务管理器之间的切换是无需修改代码的。</p>
<p>对于那些跨越了多个Hibernate会话工厂的分布式事务，只需要将<code>JtaTransactionManager</code>和多个<code>LocalSessionFactoryBean</code>定义相结合即可。每个DAO之后会获取一个特定的<code>SessionFactory</code>引用。如果所有底层JDBC数据源都是事务性容器，那么只要使用<code>JtaTransactionManager</code>作为策略实现，业务服务就可以划分任意数量的DAO和任意数量的会话工厂的事务。</p>
<p>无论是<code>HibernateTransactionManager</code>还是<code>JtaTransactionManager</code>都允许使用JVM级别的缓存来处理Hibernate，无需基于容器的事务管理器查找，或者JCA连接器（如果开发者没有使用EJB来实例化事务的话）。</p>
<p><code>HibernateTransactionManager</code>可以为指定的数据源的Hibernate JDBC的<code>Connection</code>转成为纯JDBC的访问代码。如果开发者仅访问一个数据库，则开发者完全可以不使用JTA，通过Hibernate和JDBC数据访问进行高级别事务划分。如果开发者已经通过<code>LocalSessionFactoryBean</code>的<code>dataSource</code>属性与<code>DataSource</code>设置了传入的<code>SessionFactory</code>，<code>HibernateTransactionManager</code>会自动将Hibernate事务公开为JDBC事务。或者，开发者可以通过<code>HibernateTransactionManager</code>的<code>dataSource</code>属性的配置以确定公开事务的类型。</p>
<h3>16.3.6对比由容器管理的和本地定义的资源</h3>
<p>开发者可以在不修改一行代码的情况下，在容器管理的JNDI<code>SessionFactory</code>和本地定义的<code>SessionFactory</code>之间进行切换。是否将资源定义保留在容器中，还是仅仅留在应用中，都取决于开发者使用的事务策略。相对于Spring定义的本地<code>SessionFactory</code>来说，手动注册的JNDI<code>SessionFactory</code>没有什么优势。通过Hibernate的JCA连接器来发布一个<code>SessionFactory</code>只会令代码更符合J2EE服务标准，但是并不会带来任何实际的价值。</p>
<p>Spring对事务支持不限于容器。使用除JTA之外的任何策略配置，事务都可以在独立或测试环境中工作。特别是在单数据库事务的典型情况下，Spring的单一资源本地事务支持是一种轻量级和强大的替代JTA的解决方案。当开发者使用本地EJB无状态会话Bean来驱动事务时，即使只访问单个数据库，并且只使用无状态会话Bean来通过容器管理的事务来提供声明式事务，开发者的代码依然是依赖于EJB容器和JTA的。同时，以编程方式直接使用JTA也需要一个J2EE环境的。 JTA不涉及JTA本身和JNDI DataSource实例方面的容器依赖关系。对于非Spring，JTA驱动的Hibernate事务，开发者必须使用Hibernate JCA连接器或开发额外的Hibernate事务代码，并为JVM级缓存正确配置<code>TransactionManagerLookup</code>。</p>
<p>Spring驱动的事务可以与本地定义的Hibernate<code>SessionFactory</code>一样工作，就像本地JDBC DataSource访问单个数据库一样。但是，当开发者有分布式事务的要求的情况下，只能选择使用Spring JTA事务策略。JCA连接器是需要特定容器遵循一致的部署步骤的，而且显然JCA支持是需要放在第一位的。JCA的配置需要比部署本地资源定义和Spring驱动事务的简单web应用程序需要更多额外的的工作。同时，开发者还需要使用容器的企业版，比如，如果开发者使用的是WebLogic Express的非企业版，就是不支持JCA的。具有跨越单个数据库的本地资源和事务的Spring应用程序适用于任何基于J2EE的Web容器（不包括JTA，JCA或EJB），如Tomcat，Resin或甚至是Jetty。此外，开发者可以轻松地在桌面应用程序或测试套件中重用中间层代码。</p>
<p>综合前面的叙述，如果不使用EJB，请尽量使用本地的<code>SessionFactory</code>设置和Spring的<code>HibernateTransactionManager</code>或<code>JtaTransactionManager</code>。开发者能够得到了前面提到的所有好处，包括适当的事务性JVM级缓存和分布式事务支持，而且没有容器部署的不便。只有必须配合EJB使用的时候，JNDI通过JCA连接器来注册Hibernate<code>SessionFactory</code>才有价值。</p>
<h3>16.3.7Hibernate的虚假应用服务器警告</h3>
<p>在某些具有非常严格的<code>XADataSource</code>实现的JTA环境（目前只有一些WebLogic Server和WebSphere版本）中，当配置Hibernate时，没有考虑到JTA的 <code>PlatformTransactionManager</code>对象，可能会在应用程序服务器日志中显示虚假警告或异常。这些警告或异常经常描述正在访问的连接不再有效，或者JDBC访问不再有效。这通常可能是因为事务不再有效。例如，这是WebLogic的一个实际异常：</p>
<ol>
<li><code>java.sql.SQLException: The transaction is no longer active - status: 'Committed'. No</code></li>
<li><code>further JDBC access is allowed within this transaction.</code></li>
</ol>
<p>开发者可以通过配置令Hibernate意识到Spring中同步的JTA<code>PlatformTransactionManager</code>实例的存在，这样即可消除掉前面所说的虚假警告信息。开发者有以下两种选择：</p>
<ul>
<li>如果在应用程序上下文中，开发者已经直接获取了JTA <code>PlatformTransactionManager</code>对象（可能是从JNDI到<code>JndiObjectFactoryBean</code>或者<code>&lt;jee：jndi-lookup&gt;</code>标签），并将其提供给Spring的<code>JtaTransactionManager</code>（其中最简单的方法就是指定一个引用bean将此JTA <code>PlatformTransactionManager</code>实例定义为<code>LocalSessionFactoryBean</code>的<code>jtaTransactionManager</code>属性的值）。 Spring之后会令<code>PlatformTransactionManager</code>对象对Hibernate可见。</li>
<li>更有可能开发者无法获取JTA<code>PlatformTransactionManager</code>实例，因为Spring的<code>JtaTransactionManager</code>是可以自己找到该实例的。因此，开发者需要配置Hibernate令其直接查找JTA <code>PlatformTransactionManager</code>。开发者可以如Hibernate手册中所述那样通过在Hibernate配置中配置应用程序服务器特定的<code>TransactionManagerLookup</code>类来执行此操作。</li>
</ul>
<p>本节的其余部分描述了在<code>PlatformTransactionManager</code>对Hibernate可见和<code>PlatformTransactionManager</code>对Hibernate不可见的情况下发生的事件序列:</p>
<p>当Hibernate未配置任何对JTA<code>PlatformTransactionManager</code>的进行查找时，JTA事务提交时会发生以下事件：</p>
<ul>
<li>JTA事务提交</li>
<li>Spring的<code>JtaTransactionManager</code>与JTA事务同步，所以它被JTA事务管理器通过<code>afterCompletion</code>回调调用。</li>
<li>在其他活动中，此同步令Spring通过Hibernate的<code>afterTransactionCompletion</code>触发回调（用于清除Hibernate缓存），然后在Hibernate Session上调用<code>close()</code>，从而令Hibernate尝试<code>close()</code>JDBC连接。</li>
<li>在某些环境中，因为事务已经提交，应用程序服务器会认为<code>Connection</code>不可用，导致<code>Connection.close()</code>调用会触发警告或错误。</li>
</ul>
<p>当Hibernate配置了对JTA<code>PlatformTransactionManager</code>进行查找时，JTA事务提交时会发生以下事件：</p>
<ul>
<li>JTA事务准备提交</li>
<li>Spring的<code>JtaTransactionManager</code>与JTA事务同步，所以JTA事务管理器通过<code>beforeCompletion</code>方法来回调事务。</li>
<li>Spring确定Hibernate与JTA事务同步，并且行为与前一种情况不同。假设Hibernate Session需要关闭，Spring将会关闭它。</li>
<li>JTA事务提交。</li>
<li>Hibernate与JTA事务同步，所以JTA事务管理器通过<code>afterCompletion</code>方法回调事务，可以正确清除其缓存。</li>
</ul>
<p> </p>
<h2>16.4 JPA</h2>
<p>Spring JPA在<code>org.springframework.orm.jpa</code>包中已经可用，Spring JPA用了Hibernate集成相似的方法来提供更易于理解的JPA支持，与此同时，了解了JPA底层实现，可以理解更多的Spring JPA特性。</p>
<h3>16.4.1 Spring中JPA配置的三个选项</h3>
<p>Spring JPA支持提供了三种配置JPA<code>EntityManagerFactory</code>的方法，之后通过<code>EntityManagerFactory</code>来获取对应的实体管理器。</p>
<h4>LocalEntityManagerFactoryBean</h4>
<blockquote><p>通常只有在简单的部署环境中使用此选项，例如在独立应用程序或者进行集成测试时，才会使用这种方式。</p></blockquote>
<p><code>LocalEntityManagerFactoryBean</code>创建一个适用于应用程序且仅使用JPA进行数据访问的简单部署环境的<code>EntityManagerFactory</code>。工厂bean会使用JPA<code>PersistenceProvider</code>自动检测机制，并且在大多数情况下，仅要求开发者指定持久化单元的名称：</p>
<ol>
<li><code>&lt;beans&gt;</code></li>
<li><code>&lt;bean id="myEmf" class="org.springframework.orm.jpa.LocalEntityManagerFactoryBean"&gt;</code></li>
<li><code>&lt;property name="persistenceUnitName" value="myPersistenceUnit"/&gt;</code></li>
<li><code>&lt;/bean&gt;</code></li>
<li><code>&lt;/beans&gt;</code></li>
</ol>
<p>这种形式的JPA部署是最简单的，同时限制也很多。开发者不能引用现有的JDBC<code>DataSource</code> bean定义，并且不支持全局事务。而且，持久化类的织入(weaving)(字节码转换)是特定于提供者的，通常需要在启动时指定特定的JVM代理。该选项仅适用于符合JPA Spec的独立应用程序或测试环境。</p>
<h4>从JNDI中获取EntityManagerFactory</h4>
<blockquote><p>在部署到J2EE服务器时可以使用此选项。检查服务器的文档来了解如何将自定义JPA提供程序部署到服务器中，从而对服务器进行比默认更多的个性化定制。</p></blockquote>
<p>从JNDI获取<code>EntityManagerFactory</code>(例如在Java EE环境中)，只需要在XML配置中加入配置信息即可：</p>
<ol>
<li><code>&lt;beans&gt;</code></li>
<li><code>&lt;jee:jndi-lookup id="myEmf" jndi-name="persistence/myPersistenceUnit"/&gt;</code></li>
<li><code>&lt;/beans&gt;</code></li>
</ol>
<p>此操作将采用标准J2EE引导：J2EE服务器自动检测J2EE部署描述符（例如web.xml）中persistence-unit-ref条目和持久性单元（实际上是应用程序jar中的META-INF/persistence.xml文件），并为这些持久性单元定义环境上下文位置。</p>
<p>在这种情况下，整个持久化单元部署（包括持久化类的织入(weaving)（字节码转换））都取决于J2EE服务器。JDBC <code>DataSource</code>通过META-INF/persistence.xml文件中的JNDI位置进行定义; 而<code>EntityManager</code>事务与服务器JTA子系统集成。 Spring仅使用获取的<code>EntityManagerFactory</code>，通过依赖注入将其传递给应用程序对象，通常通过<code>JtaTransactionManager</code>来管理持久性单元的事务。</p>
<p>如果在同一应用程序中使用多个持久性单元，则这种JNDI检索的持久性单元的bean名称应与应用程序用于引用它们的持久性单元名称相匹配，例如<code>@PersistenceUnit</code>和<code>@PersistenceContext</code>注释。</p>
<h4>LocalContainerEntityManagerFactoryBean</h4>
<blockquote><p>在基于Spring的应用程序环境中使用此选项来实现完整的JPA功能。这包括诸如Tomcat的Web容器，以及具有复杂持久性要求的独立应用程序和集成测试。</p></blockquote>
<p><code>LocalContainerEntityManagerFactoryBean</code>可以完全控制<code>EntityManagerFactory</code>的配置，同时适用于需要细粒度定制的环境。 <code>LocalContainerEntityManagerFactoryBean</code>会基于<code>persistence.xml</code>文件，<code>dataSourceLookup</code>策略和指定的<code>loadTimeWeaver</code>来创建一个<code>PersistenceUnitInfo</code>实例。因此，可以在JNDI之外使用自定义数据源并控制织入(weaving)过程。以下示例显示<code>LocalContainerEntityManagerFactoryBean</code>的典型Bean定义：</p>
<ol>
<li><code>&lt;beans&gt;</code></li>
<li><code>&lt;bean id="myEmf" class="org.springframework.orm.jpa.LocalContainerEntityManagerFactoryBean"&gt;</code></li>
<li><code>&lt;property name="dataSource" ref="someDataSource"/&gt;</code></li>
<li><code>&lt;property name="loadTimeWeaver"&gt;</code></li>
<li><code>&lt;bean class="org.springframework.instrument.classloading.InstrumentationLoadTimeWeaver"/&gt;</code></li>
<li><code>&lt;/property&gt;</code></li>
<li><code>&lt;/bean&gt;</code></li>
<li><code>&lt;/beans&gt;</code></li>
</ol>
<p>下面的例子是一个典型的persistence.xml文件：</p>
<ol>
<li><code>&lt;persistence xmlns="http://java.sun.com/xml/ns/persistence" version="1.0"&gt;</code></li>
<li><code>&lt;persistence-unit name="myUnit" transaction-type="RESOURCE_LOCAL"&gt;</code></li>
<li><code>&lt;mapping-file&gt;META-INF/orm.xml&lt;/mapping-file&gt;</code></li>
<li><code>&lt;exclude-unlisted-classes/&gt;</code></li>
<li><code>&lt;/persistence-unit&gt;</code></li>
<li><code>&lt;/persistence&gt;</code></li>
</ol>
<blockquote><p><code>&lt;exclude-unlisted-classes /&gt;</code>标签表示不会进行注解实体类的扫描。指定的显式<code>true</code>值 – <code>&lt;exclude-unlisted-classes&gt;true&lt;/exclude-unlisted-classes/&gt;</code>– 也意味着不进行扫描。<code>&lt;exclude-unlisted-classes&gt; false&lt;/exclude-unlisted-classes&gt;</code>则会触发扫描;但是，如果开发者需要进行实体类扫描，建议开发者简单地省略<code>&lt;exclude-unlisted-classes&gt;</code>元素。</p></blockquote>
<p><code>LocalContainerEntityManagerFactoryBean</code>是最强大的JPA设置选项，允许在应用程序中进行灵活的本地配置。它支持连接到现有的JDBC<code>DataSource</code>，支持本地和全局事务等。但是，它对运行时环境施加了需求，其中之一就是如果持久性提供程序需要字节码转换，就需要有织入(weaving)能力的类加载器。</p>
<p>此选项可能与J2EE服务器的内置JPA功能冲突。在完整的J2EE环境中，请考虑从JNDI获取<code>EntityManagerFactory</code>。或者，在开发者的<code>LocalContainerEntityManagerFactoryBean</code>定义中指定一个自定义<code>persistenceXmlLocation</code>，例如META-INF/my-persistence.xml，并且只在应用程序jar文件中包含有该名称的描述符。因为J2EE服务器仅查找默认的META-INF/persistence.xml文件，所以它会忽略这种自定义持久性单元，从而避免了与Spring驱动的JPA设置之间发生冲突。 （例如，这适用于Resin 3.1）</p>
<blockquote><p>何时需要加载时间织入？</p>
<p>并非所有JPA提供商都需要JVM代理。Hibernate就是一个不需要JVM代理的例子。如果开发者的提供商不需要代理或开发者有其他替代方案，例如通过定制编译器或<code>Ant</code>任务在构建时应用增强功能，则不用使用加载时间编织器。</p></blockquote>
<p><code>LoadTimeWeaver</code>是一个Spring提供的接口，它允许以特定方式插入JPA<code>ClassTransformer</code>实例，这取决于环境是Web容器还是应用程序服务器。 通过代理挂载<code>ClassTransformers</code>通常性能较差。<a href="https://docs.oracle.com/javase/6/docs/api/java/lang/instrument/package-summary.html" rel="external nofollow noreferrer">代理</a>会对整个虚拟机进行操作，并检查加载的每个类，这是生产服务器环境中最不需要的额外负载。</p>
<p>Spring为各种环境提供了一些<code>LoadTimeWeaver</code>实现，允许<code>ClassTransformer</code>实例仅适用于每个类加载器，而不是每个VM。</p>
<p>有关<code>LoadTimeWeaver</code>的实现及其设置的通用或定制的各种平台（如Tomcat，WebLogic，GlassFish，Resin和JBoss）的更多了解，请参阅AOP章节中的<a href="http://docs.spring.io/spring/docs/5.0.0.BUILD-SNAPSHOT/spring-framework-reference/htmlsingle/#aop-aj-ltw-spring" rel="external nofollow noreferrer">Spring配置</a>一节。</p>
<p>如前面部分所述，开发者可以使用<code>@EnableLoadTimeWeaving</code>注解或者<code>load-time-weaver</code>XML元素来配置上下文范围的<code>LoadTimeWeaver</code>。所有JPA<code>LocalContainerEntityManagerFactoryBeans</code>都会自动拾取这样的全局织入器。这是设置加载时间织入器的首选方式，为平台（WebLogic，GlassFish，Tomcat，Resin，JBoss或VM代理）提供自动检测功能，并将织入组件自动传播到所有可以感知织入者的Bean：</p>
<ol>
<li><code>&lt;context:load-time-weaver/&gt;</code></li>
<li><code>&lt;bean id="emf" class="org.springframework.orm.jpa.LocalContainerEntityManagerFactoryBean"&gt;</code></li>
<li><code>...</code></li>
<li><code>&lt;/bean&gt;</code></li>
</ol>
<p>开发者也可以通过<code>LocalContainerEntityManagerFactoryBean</code>的<code>loadTimeWeaver</code>属性来手动指定专用的织入器：</p>
<ol>
<li><code>&lt;bean id="emf" class="org.springframework.orm.jpa.LocalContainerEntityManagerFactoryBean"&gt;</code></li>
<li><code>&lt;property name="loadTimeWeaver"&gt;</code></li>
<li><code>&lt;bean class="org.springframework.instrument.classloading.ReflectiveLoadTimeWeaver"/&gt;</code></li>
<li><code>&lt;/property&gt;</code></li>
<li><code>&lt;/bean&gt;</code></li>
</ol>
<p>无论LTW如何配置，使用这种技术，依赖于仪器的JPA应用程序都可以在目标平台（例如：Tomcat）中运行，而不需要代理。这尤其重要的是当主机应用程序依赖于不同的JPA实现时，因为JPA转换器仅应用于类加载器级，彼此隔离。</p>
<h4>处理多个持久化单元</h4>
<p>例如，对于依赖存储在类路径中的各种JARS中的多个持久性单元位置的应用程序，Spring将<code>PersistenceUnitManager</code>作为中央仓库来避免可能昂贵的持久性单元发现过程。默认实现允许指定多个位置，这些位置将通过持久性单元名称进行解析并稍后检索。（默认情况下，搜索classpath下的META-INF/persistence.xml文件。）</p>
<ol>
<li><code>&lt;bean id="pum" class="org.springframework.orm.jpa.persistenceunit.DefaultPersistenceUnitManager"&gt;</code></li>
<li><code>&lt;property name="persistenceXmlLocations"&gt;</code></li>
<li><code>&lt;list&gt;</code></li>
<li><code>&lt;value&gt;org/springframework/orm/jpa/domain/persistence-multi.xml&lt;/value&gt;</code></li>
<li><code>&lt;value&gt;classpath:/my/package/**/custom-persistence.xml&lt;/value&gt;</code></li>
<li><code>&lt;value&gt;classpath*:META-INF/persistence.xml&lt;/value&gt;</code></li>
<li><code>&lt;/list&gt;</code></li>
<li><code>&lt;/property&gt;</code></li>
<li><code>&lt;property name="dataSources"&gt;</code></li>
<li><code>&lt;map&gt;</code></li>
<li><code>&lt;entry key="localDataSource" value-ref="local-db"/&gt;</code></li>
<li><code>&lt;entry key="remoteDataSource" value-ref="remote-db"/&gt;</code></li>
<li><code>&lt;/map&gt;</code></li>
<li><code>&lt;/property&gt;</code></li>
<li><code>&lt;!-- if no datasource is specified, use this one --&gt;</code></li>
<li><code>&lt;property name="defaultDataSource" ref="remoteDataSource"/&gt;</code></li>
<li><code>&lt;/bean&gt;</code></li>
<li><code></code></li>
<li><code>&lt;bean id="emf" class="org.springframework.orm.jpa.LocalContainerEntityManagerFactoryBean"&gt;</code></li>
<li><code>&lt;property name="persistenceUnitManager" ref="pum"/&gt;</code></li>
<li><code>&lt;property name="persistenceUnitName" value="myCustomUnit"/&gt;</code></li>
<li><code>&lt;/bean&gt;</code></li>
</ol>
<p>在默认实现传递给JPA provider之前，是允许通过属性（影响全部持久化单元）或者通过<code>PersistenceUnitPostProcessor</code>以编程(对选择的持久化单元进行)进行对<code>PersistenceUnitInfo</code>进行自定义的。如果没有指定<code>PersistenceUnitManager</code>，则由<code>LocalContainerEntityManagerFactoryBean</code>在内部创建和使用。</p>
<h3>转载自 <a href="http://ifeve.com/" rel="external nofollow noreferrer">并发编程网 - ifeve.com</a></h3>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-20 21:44:56</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%9c%8d%e5%8a%a1%e5%99%a8/" title="服务器">服务器</a>, <a href="https://www.iamivan.net/tag/%e9%85%8d%e7%bd%ae/" title="配置">配置</a>, <a href="https://www.iamivan.net/tag/xml/" title="xml">xml</a>, <a href="https://www.iamivan.net/tag/%e5%ae%b9%e5%99%a8/" title="容器">容器</a>, <a href="https://www.iamivan.net/tag/class/" title="class">class</a>, <a href="https://www.iamivan.net/tag/bean/" title="bean">bean</a>, <a href="https://www.iamivan.net/tag/hibernate/" title="Hibernate">Hibernate</a>, <a href="https://www.iamivan.net/tag/jdbc/" title="jdbc">jdbc</a>, <a href="https://www.iamivan.net/tag/spring/" title="spring">spring</a>, <a href="https://www.iamivan.net/tag/j2ee/" title="j2ee">j2ee</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>《Spring 5 官方文档》16.ORM和数据访问（二）的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z7wYV5z.html" rel="bookmark">《Spring 5官方文档》11集成测试 （二）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				11.3 JDBC测试支持 org.springframework.test.jdbc是包含JdbcTestUtils的包,它是一个JDBC相关的工具方法集,意在简化标准数据库测试场景.特别地,JdbcTestUtils提供以下静态工具方法: countRowsInTable(..):统计给定表的行数. countRowsInTableWhere(..):使用提供的where语句进行筛选统计给定表的行数. deleteFromTables(..):删除特定表的全部数据. deleteFromTa			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MvrWA8M.html" rel="bookmark">《Spring 5 官方文档》4&period; 资源（二）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				4.6 资源依赖 如果bean本身将通过某种动态过程来确定和提供资源路径,那么bean可以使用ResourceLoader接口来加载资源. j假设以某种方式加载一个模板,其中需要的特定资源取决于用户的角色. 如果资源是静态的,那么完全消除ResourceLoader接口的使用是有意义的,只需让bean公开它需要的Resource属性,那么它们就会以你所期望的方式被注入. 什么使得它们轻松注入这些属性,是所有应用程序上下文注册和使用一个特殊的JavaBeans PropertyEditor,它可以			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M1D2ZKb.html" rel="bookmark">《Spring 5 官方文档》26&period; JMS（二）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				26.4 接收消息 26.4.1 同步接收 虽然 JMS 通常与异步处理相关,但它也可以同步地消费消息.可重载的receive(..)方法提供了这个功能.在同步接收期间,调用线程阻塞,直到接收到消息.这可能是一个危险的操作,因为调用线程可能无限期地被阻塞.receiveTimeout属性指定了接收者等待消息的超时时间. 26.4.2 异步接收 – 消息驱动的 POJOs Spring 还可以通过使用@JmsListener注解来支持监听注解端点,并提供了一种以编程方式注册端点的开放式基础架构.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MAk76nz.html" rel="bookmark">《Spring 5官方文档》翻译邀请</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				公司新的应用已经开始使用Spring 5,所以本月组织大家翻译&lt;Spring 5 官方文档&gt; SINGLE网页版  PDF版本. 如何领取 通过评论领取想要翻译的文章,每次领取一章或一节(根据内容长短),翻译完后再领取其他章节.领取完成之后,建议在一个星期内翻译完成,如果不能完成翻译,也欢迎你邀请其他同学和你一起完成翻译.请谨慎领取,并发网是非盈利组织,没办法去跟进每一篇译文的进展,所以很多文章领取了没有翻译,会导致文章长时间没人翻译. 如何提交? 翻译完成之后请登录到并发编程网后台,点击左上			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/My35Gdz.html" rel="bookmark">《Spring 5 官方文档》16&period;ORM和数据访问（一）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				16.1介绍一下Spring中的ORM Spring框架在实现资源管理.数据访问对象(DAO)层,和事务策略等方面,支持对Java持久化API(JPA)以及原生Hibernate的集成.以Hibernate举例来说,Spring有非常赞的IoC功能,可以解决许多典型的Hibernate配置和集成问题.开发者可以通过依赖注入来配置O-R(对象关系)映射组件支持的特性.Hibernate的这些特性可以参与Spring的资源和事务管理,并且符合Spring的通用事务和DAO层的异常体系.因此,Spri			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pkwo81p.html" rel="bookmark">《Spring 5 官方文档》16&period;ORM和数据访问（三）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				16.4.2 基于JPA的EntityManagerFactory和EntityManager来实现DAO 虽然EntityManagerFactory实例是线程安全的,但EntityManager实例不是.注入的JPA EntityManager的行为类似于从JPA Spec中定义的应用程序服务器的JNDI环境中提取的EntityManager.它将所有调用委托给当前事务的EntityManager(如果有);否则,它每个操作返回的都是新创建的EntityManager,通过使用不同的Enti			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b3EEBkp.html" rel="bookmark">《Spring Boot官方文档》16&period; 自动配置</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				16. 自动配置 Spring Boot的自动配置会尝试根据你添加进来的jar依赖来自动配置你的Spring应用.例如,如果HSQLDB在你的classpath路径上,你没有手动配置任何数据库连接实体类,我们还会自动配置内存数据库. 你可以有选择的实现自动配置,可以向 @Configuration上添加@EnableAutoConfiguration或者@SpringBootApplication注解来实现. 你应该只添加一个@EnableAutoConfiguration注解.我们通常建议你把			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pn7N0Az.html" rel="bookmark">Spring Data 官方文档》4&period;7 Spring Data扩展</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				4.7 Spring Data扩展 这部分说明Spring Data一系列的扩展功能,可以使Spring Dta使用多样的上下文.目前大部分集成是针对Spring MVC. 4.7.1 Querydsl扩展 Querydsl是一个框架,通过它的流式API构建静态类型的SQL类查询.多个Spring Data模块通过QueryDslPredicateExecutor与Querydsl集成. 例29 QueryDslPredicateExecutor接口 1 public interface Que			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z42Qe1M.html" rel="bookmark">《Spring 5官方文档》电子邮件</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				29. 电子邮件 29.1 介绍 依赖库:使用Spring框架的邮件功能需要将JavaMail的Jar包添加到依赖中.这个库可以Maven中心找到:com.sun.mail:javax.mail. Spring提供了一个实用的发送电子邮件库,它为使用者屏蔽了邮件系统的底层细节和客户端的底层资源处理. Spring邮件相关功能在org.springframework.mail包下,其中MailSender是发送邮件的核心接口:SimpleMailMessage类是对邮件属性(发件人.收件人以等)进			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/dzZRm5z.html" rel="bookmark" class="title">word2013中怎样进行屏幕截图</a>
					<div>
						  屏幕截图步骤1:打开我们需要截图的窗口. 屏幕截图步骤2:用Word2013打开一篇文档,将光标定位在我们需要插入截图的地方,并切换到&quot;插入&quot;选项卡,单击&quot;插图&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/yMAQx3M.html" rel="bookmark" class="title">DIV&plus;CSS布局入门教程&lpar;六&rpar; -- 关于ID和CLASS</a>
					<div>
						css|教程|入门教程 这半个月以来今天是头一天在20:00左右下班,想起关于这个教程一直没有完成,心里感觉非常不踏实.两个月前刚辞职,本想把教程全部完成,但是由于一次不幸,导致硬盘中的数据大部分丢失 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/2pLXP0p.html" rel="bookmark" class="title">使用Iptables的功能扩展全面封杀P2P流量</a>
					<div>
						Linux真是好东西啊!Linux系统不但稳定,平台相对安全,而且还是开放源代码且是免费的,其中的iptables更是功能强大,所以笔者公司一直在用他做公司的内部网关, 并通过iptables 的设置 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/2pLANkz.html" rel="bookmark" class="title">百度营销之竞价战略精髓篇</a>
					<div>
						百度营销,分免费和付费两种.免费的也就是说利用百度自身的产品做推广,其实也是网络推广的一部分;付费当属竞价和百度广告联盟.百度推广和百度联盟,这里俺就不多说了,今天主讲百度竞价.做网络营销咱得跟着百度 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMyDg8b.html" rel="bookmark" class="title">如何用ASP编写网站统计系统三</a>
					<div>
						 设计表结构是一项极其重要的工作,它的合理与否与程序的编制紧密相关.一个网站统计系统应该有一个用户表,统计值表.这个用户表也就是保留注册用户信息的表,统计值表就是记录用户的每一项统计指标值的表.在统计 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/jbEB5qM.html" rel="bookmark" class="title">从百度搜索结果网址的变化看未来优化之路</a>
					<div>
						在经历一轮大的百度K站风波之后,百度近期并无大的动静,这让我们站长们稍稍松了一口气,但细心的站长仍可以发现百度还是有点小变化的.平时搜索一些关键词,在得到的结果中,研究对手的网站时,我比较喜欢直接在百 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwlN4Wb.html" rel="bookmark" class="title">MySQL引擎 学习笔记</a>
					<div>
						  一般来说,MySQL有以下几种引擎:ISAM.MyISAM.HEAP.InnoDB和Berkley(BDB).注意:不同的版本支持的引擎是有差异的.当然啦,如果你感觉自己的确技术高超,你还能够使用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/balR1Qz.html" rel="bookmark" class="title">如何清空文件夹里面的所有文件和文件夹</a>
					<div>
						以下是对c#中清空文件夹里面的所有文件和文件夹的实现代码进行了详细的分析介绍,需要的朋友可以参考下   复制代码 代码如下: private void deletefileOrDic(System.I ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6e3kNb.html" rel="bookmark" class="title">WPS文字怎么添加自定义水印</a>
					<div>
						  简单的添加默认设置好的水印,如下图: 添加属于自己的水印步骤: 1:点击添加水印. 2:设置好属于你自己的水印,点击确定. 取消水印步骤:					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pP8lGrp.html" rel="bookmark" class="title">Excel2013怎么设置打开密码？</a>
					<div>
						  前面我们了解了给Excel2013中特定区域单元格加密的方法,现在,小编要给大家分享的是,如何在Excel2013中设置打开密码,完成之后需要密码才能打开这个工作表哦. 操作步骤如下: 1.用Ex ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxW5PBb.html" rel="bookmark" class="title">PS制作拼图效果的动态签</a>
					<div>
						  效果图 1.新建500*200,拖入一张图移动到合适位置 2.利用视图--标尺;视图--新建参考线 将图均分为10份 3.将每份分别剪切后原位粘贴,成为10个图层(我用的是本办法,一个一个选区后剪 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3o18Ab.html" rel="bookmark" class="title">支付宝怎么修改支付密码？</a>
					<div>
						  1.进入支付宝-账户设置-安全设置,点击支付密码一栏后方的[修改]按钮. 2.输入原密码和新设置的密码,点击[确定] 3.密码修改成功.					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYRYJ6p.html" rel="bookmark" class="title">Mac复制文件路径详细教程</a>
					<div>
						  第一步:打开一个TXT的文档. 第二步:选择自己想要查看的文件,支持批量查看. 第三步:就能显示出所要查看文件夹的文件路径地址.					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mr3xexp.html" rel="bookmark" class="title">Symfony2 session用法实例分析&lowbar;php实例</a>
					<div>
						本文实例分析了Symfony2 session用法.分享给大家供大家参考,具体如下: Symfony自带有session的方法,以前老版本2.2及以前的session用法是 $session = $t ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgVyo8b.html" rel="bookmark" class="title">CentOS6使用第三方YUM源（EPEL、RPMForge和RPMFusion）</a>
					<div>
						CentOS自带的yum源中rpm包数量有限,很多时候找不到我们需的软件包,所以我们需要安装包含丰富的第三方YUM源来满足我们的需求. 1.安装yum-priorities插件 [root@local ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7YrnrM.html" rel="bookmark" class="title">为什么demo里面的发送文件和发送图片都是进图片选择页面</a>
					<div>
						问题描述 demo没做发送文件么? 解决方案 有的啊,你去看解决方案二:这个 问题 我刚解决 这个是与你手机Android版本有关的 在4.4之前的版本 能打开文件选择 但是4.4以及之后打开文件选择 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4NOOYM.html" rel="bookmark" class="title">System&period;DateTime&period;now奇怪问题，如何解决？</a>
					<div>
						问题描述 System.DateTime.Now.ToString()在不同的电脑上执行的结果却不一样一种是21/7/2008PM5:30:42一种是2008-7-2117:31:51我只想要2008 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwW1Zmz.html" rel="bookmark" class="title">ACL 2017，Facebook带来了哪些精彩内容？</a>
					<div>
						雷锋网(公众号:雷锋网) AI科技评论按:ACL 2017已经在加拿大温哥华拉开帷幕,本次会议收录论文创下历史新高,除了论文展示还有workshop和软件展示.Facebook的研究员也会在ACL 2 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlK3xYb.html" rel="bookmark" class="title">《Cisco QoS认证考试指南（第2版）》&mdash;&mdash;6&period;3节流量限速和流量整形概念</a>
					<div>
						6.3 流量限速和流量整形概念 Cisco QoS认证考试指南(第2版) 流量整形和流量限速都会测量发送或接收数据的速率.限速特性会丢弃超出门限值的数据包,使整体限速后的速率不会超出设定.整形特性会将 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPkZe1M.html" rel="bookmark" class="title">Java递归搜索指定文件夹下的匹配文件</a>
					<div>
						  package com.lzx.file; import java.io.File; import java.util.ArrayList; import java.util.LinkedList ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWWN8qM.html" rel="bookmark" class="title">string-java 怎么给按钮设置索引？</a>
					<div>
						问题描述 java 怎么给按钮设置索引? 我想给按钮4和按钮5添加鼠标单击事件,但是我不知道怎么加,求大神给个方法 import java.awt.*; import javax.swing.*; p ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq7oBGz.html" rel="bookmark" class="title">oracle7 3-java使用哪种方式可以连接Oracle7&period;3</a>
					<div>
						问题描述 java使用哪种方式可以连接Oracle7.3 客户端是Oracle10g客户端,服务器是Oracle7.3,不能使用thin连接,也不能使用ODBC连接,我还能使用哪种方式连接呢,急求答案 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvnA6NM.html" rel="bookmark" class="title">分析百度有啊不再使用独立域名</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 今天访问了一下百度有啊,发现有啊已 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnRBjOp.html" rel="bookmark" class="title">中国数字阅读平台的希望依旧渺茫</a>
					<div>
						中介交易 SEO诊断 淘宝客 云主机 技术大厅 很多时候人们每天都不得不保持快节奏的生活方式,在等人.乘坐公交地铁等零散的时间里,打开电子产品中的阅读器看上几页小说成为了人们轻松度过这段时间的最佳选择 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M12Kgdp.html" rel="bookmark" class="title">韩娱每周一星：&OpenCurlyDoubleQuote;禽兽偶像&rdquo;代言人玉泽演&lpar;图&rpar;</a>
					<div>
						阳光型男玉泽演 编者按:在汰旧换新速度飞快的娱乐界,人气的保质期是非常短暂的.今天还是娱乐头条,明天可能就会被后来者取代.但不管他们的星途指向何方,最闪耀的时刻都是应该被铭记的,新浪韩娱每周一星就是要 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pX0DRlp.html" rel="bookmark" class="title">魅族的2014是有多风骚？</a>
					<div>
						   今年国内的手机行业比以往任何时候都热闹,数不清的大事件,扯不完的小恩怨,人们喜闻乐见国产手机你死我活下的集体崛起,但洗牌终归是残酷的,2014对魅族来说有太多故事,出货量翻番,营收增长40%,这 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MR1NBxb.html" rel="bookmark" class="title">EasyASP v1&period;5发布&lpar;包含数据库操作类，原clsDbCtrl&period;asp&rpar;第1&sol;2页&lowbar;ASP CLASS类</a>
					<div>
						而Easp类中提供了大量实用的ASP通用过程及方法,可以简化大部分的ASP操作.目前只提供了VBScript版,JScript版将来可能会提供.EasyASP v1.5 (2008-10-22更新)  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPlaNAp.html" rel="bookmark" class="title">典型入侵日志分析&lowbar;漏洞研究</a>
					<div>
						1．FTP日志分析  FTP日志和WWW日志在默认情况下,每天生成一个日志文件,包含了该日的一切记录,文件名通常为ex(年份)(月份)(日期).例如ex040419,就是2004年4月19日产生的日志 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9j7P3p.html" rel="bookmark" class="title">K歌达人APP和陌生人聊天方法</a>
					<div>
						给各位K歌达人软件的使用者们来详细的解析分享一下和陌生人聊天的方法. 方法分享: 1.打开k歌达人,进入首页后点击一位用户的[头像],进入到TA的个人主页,点击[资料]页面.     2.接着点击[聊 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEYvqLb.html" rel="bookmark" class="title">请教一个软件开发意向的问题</a>
					<div>
						问题描述 想搞一个软件,可以通过终端进行实时定位监控的,当然这是合法的.定位终端不能使用手机卡,只能采用别的方法.有没有大神能够有想法的,或加QQ1017505618详谈~~ 解决方案 解决方案二:只 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.032 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
